// Auto-generated by mpsidl
#ifndef MPS_mpsnaming_H
#define MPS_mpsnaming_H

#include <string>
#include <vector>

#include <mps/mps.h>
#include <mps/mpsnaming.h>

namespace org {
namespace hebe {
namespace mps {
namespace naming {
class Binding {
public:
    Binding() {}
    Binding(
        string const& objectName,
        string const& address)
    {
        this->objectName = objectName;
        this->address = address;
    }

    Binding(MPS::InputStream &__input) {
        string __sym0 = __input.readstring();
        objectName = __sym0;
        string __sym1 = __input.readstring();
        address = __sym1;
    }

    void __writeTo(MPS::OutputStream &__output) const {
        __output.writestring(objectName);
        __output.writestring(address);
    }

private:
    string objectName;
    string address;

public:
    string get_objectName() { return objectName; }
    string get_address() { return address; }

};

class NamingService: public MPS::Interface {
public:
    static ref<NamingService> _attach(string const &address);

    virtual string resolve(
        string const& objectName) = 0;
    virtual bool bind(
        string const& objectName,
        string const& address,
        bool replace) = 0;
    virtual bool unbind(
        string const& objectName) = 0;
    virtual vector< org::hebe::mps::naming::Binding > enumerate() = 0;
};

class NamingServiceProxy: public MPS::Proxy, public NamingService {
public:
    NamingServiceProxy(string const &_address)
        : MPS::Proxy(_address)
    { _setRemoteAddress(_address); }

    virtual ~NamingServiceProxy() {}

    void _fill_resolve(MPS::OutputStream &__output,
        string const& objectName);
    string _decode_resolve(MPS::InputStream &__input);

    void _send_resolve(
        string const& objectName) {
        MPS::OutputStream *__output = MPS::Proxy::_connection->getOutputStream();
        _fill_resolve(*__output,
            objectName);
        __output->flush();
        MPS::Proxy::_connection->releaseOutputStream(__output);
    }

    virtual string resolve(
        string const& objectName) {
        _send_resolve(
            objectName);
        MPS::InputStream *__input = MPS::Proxy::_connection->getInputStream();
        try {
            string __result = _decode_resolve(*__input);
            MPS::Proxy::_connection->releaseInputStream(__input);
            return __result;
        } catch (...) {
            MPS::Proxy::_connection->releaseInputStream(__input);
            throw;
        }
    }

    void _fill_bind(MPS::OutputStream &__output,
        string const& objectName,
        string const& address,
        bool replace);
    bool _decode_bind(MPS::InputStream &__input);

    void _send_bind(
        string const& objectName,
        string const& address,
        bool replace) {
        MPS::OutputStream *__output = MPS::Proxy::_connection->getOutputStream();
        _fill_bind(*__output,
            objectName,
            address,
            replace);
        __output->flush();
        MPS::Proxy::_connection->releaseOutputStream(__output);
    }

    virtual bool bind(
        string const& objectName,
        string const& address,
        bool replace) {
        _send_bind(
            objectName,
            address,
            replace);
        MPS::InputStream *__input = MPS::Proxy::_connection->getInputStream();
        try {
            bool __result = _decode_bind(*__input);
            MPS::Proxy::_connection->releaseInputStream(__input);
            return __result;
        } catch (...) {
            MPS::Proxy::_connection->releaseInputStream(__input);
            throw;
        }
    }

    void _fill_unbind(MPS::OutputStream &__output,
        string const& objectName);
    bool _decode_unbind(MPS::InputStream &__input);

    void _send_unbind(
        string const& objectName) {
        MPS::OutputStream *__output = MPS::Proxy::_connection->getOutputStream();
        _fill_unbind(*__output,
            objectName);
        __output->flush();
        MPS::Proxy::_connection->releaseOutputStream(__output);
    }

    virtual bool unbind(
        string const& objectName) {
        _send_unbind(
            objectName);
        MPS::InputStream *__input = MPS::Proxy::_connection->getInputStream();
        try {
            bool __result = _decode_unbind(*__input);
            MPS::Proxy::_connection->releaseInputStream(__input);
            return __result;
        } catch (...) {
            MPS::Proxy::_connection->releaseInputStream(__input);
            throw;
        }
    }

    void _fill_enumerate(MPS::OutputStream &__output);
    vector< org::hebe::mps::naming::Binding > _decode_enumerate(MPS::InputStream &__input);

    void _send_enumerate() {
        MPS::OutputStream *__output = MPS::Proxy::_connection->getOutputStream();
        _fill_enumerate(*__output);
        __output->flush();
        MPS::Proxy::_connection->releaseOutputStream(__output);
    }

    virtual vector< org::hebe::mps::naming::Binding > enumerate() {
        _send_enumerate();
        MPS::InputStream *__input = MPS::Proxy::_connection->getInputStream();
        try {
            vector< org::hebe::mps::naming::Binding > __result = _decode_enumerate(*__input);
            MPS::Proxy::_connection->releaseInputStream(__input);
            return __result;
        } catch (...) {
            MPS::Proxy::_connection->releaseInputStream(__input);
            throw;
        }
    }

};

class NamingServiceServer: public MPS::InterfaceServer {
public:
    NamingServiceServer(string const &objectName,
             ref<NamingService> const &impl)
        : MPS::InterfaceServer(objectName, impl)
    {
        setupMethods();
    }

private:
    void setupMethods();
    static void do_resolve(ref<MPS::Interface> const &__impl_base,
                      MPS::InputStream &__input,
                      MPS::OutputStream &__output);
    static void do_bind(ref<MPS::Interface> const &__impl_base,
                      MPS::InputStream &__input,
                      MPS::OutputStream &__output);
    static void do_unbind(ref<MPS::Interface> const &__impl_base,
                      MPS::InputStream &__input,
                      MPS::OutputStream &__output);
    static void do_enumerate(ref<MPS::Interface> const &__impl_base,
                      MPS::InputStream &__input,
                      MPS::OutputStream &__output);
};

} // end namespace naming
} // end namespace mps
} // end namespace hebe
} // end namespace org
#endif
